package com.jwk.spring.boot.autoconfigure;

import org.springframework.beans.BeansException;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.beans.factory.support.BeanDefinitionRegistry;
import org.springframework.beans.factory.support.BeanDefinitionRegistryPostProcessor;
import org.springframework.beans.factory.support.RootBeanDefinition;

/**
 * @author JWK
 * @version 1.0
 * @date 2022/12/7 13:02
 */
public class MyRegistryPostProcessor implements BeanDefinitionRegistryPostProcessor {

    private DemoProperties demoProperties;

    public MyRegistryPostProcessor(DemoProperties demoProperties) {
        this.demoProperties = demoProperties;
    }

    @Override
    public void postProcessBeanDefinitionRegistry(BeanDefinitionRegistry beanDefinitionRegistry) throws BeansException {
        RootBeanDefinition beanDefinition = new RootBeanDefinition(DemoTemplate.class);
        beanDefinition.setScope(ConfigurableBeanFactory.SCOPE_SINGLETON);
        MutablePropertyValues values = new MutablePropertyValues();
        values.addPropertyValue("tt1","111");
        values.addPropertyValue("tt2","222");
        beanDefinition.setPropertyValues(values);
        beanDefinitionRegistry.registerBeanDefinition("demoTemplate", beanDefinition);

        RootBeanDefinition beanDefinition1 = new RootBeanDefinition(DemoTemplate.class);
        beanDefinition1.setScope(ConfigurableBeanFactory.SCOPE_SINGLETON);
        MutablePropertyValues values1 = new MutablePropertyValues();
        values1.addPropertyValue("tt1","1111");
        values1.addPropertyValue("tt2","2222");
        beanDefinition1.setPropertyValues(values1);
        beanDefinitionRegistry.registerBeanDefinition("demoTemplate01", beanDefinition1);
    }

    @Override
    public void postProcessBeanFactory(ConfigurableListableBeanFactory configurableListableBeanFactory) throws BeansException {

    }
}
